package net.sourceforge.webstretch.response;

/**
 * @author Simon Shanks
 */
public abstract class AbstractHTMLResponse extends AbstractResponse{
	
	private static final String LINK_HOME="http://webstretch/";
	private static final String LINK_HELP="http://webstretch/help_action";
	private static final String LINK_CONFIGSERVER="http://webstretch/configserver_action";
	private static final String LINK_CONFIGREQUEST="http://webstretch/configrequest_action";
	private static final String LINK_SHUTDOWN="http://webstretch/shutdown_action";
	private static final String LINK_REQUEST="http://webstretch/request_action";
	private static final String LINK_STATISTICS="http://webstretch/statistics_action";
	
	private static final String getCSSForPage(){
		StringBuffer cssContent = new StringBuffer();
		cssContent.append("<style>");
		
		cssContent.append("blacktext{FONT-WEIGHT: normal; ");
		cssContent.append("  FONT-SIZE: 10px;COLOR: red; LINE-HEIGHT: 20px;"); 
		cssContent.append("  FONT-FAMILY: Verdana, Arial, Helvetica, sans-serif}");
		cssContent.append("body {");
		cssContent.append("  FONT-WEIGHT: normal;FONT-SIZE: 10px; COLOR: #000000; ");
		cssContent.append("  FONT-FAMILY: Verdana, Arial, Helvetica, sans-serif}");
		cssContent.append("p {");
		cssContent.append("  margin:1em 0 1em 0;}");
		cssContent.append("p.dashed{");
		cssContent.append("  margin:2em 0 1em 0;");
		cssContent.append("  border-top:1px dashed #999;}");
		cssContent.append("form {");
		cssContent.append("  margin:0;padding:0;}");		
		cssContent.append("dl, ul, ol {");
		cssContent.append("  margin-top:0; margin-bottom:0;}");
		cssContent.append("li {");
		cssContent.append("  margin:0 0 5px 5px;");
		cssContent.append("  list-style-position:outside;}");  
		cssContent.append("input, select, textarea {");
		cssContent.append("  font:10px Verdana,Sans-serif;");
		cssContent.append("  margin:1px 1px 1px 1px;}");
		cssContent.append("input, textarea {");
		cssContent.append("  width:300;border-width:2;}");
		cssContent.append("textarea {");
		cssContent.append("  line-height:140%;}");
		cssContent.append("table{");
		cssContent.append("	width:100%;}");
		cssContent.append("th {");
		cssContent.append("	 color:#FFFFFF;");
		cssContent.append("	 background:#666;");
		cssContent.append("  font-size:0.8em;");
		cssContent.append("	 font-weight: bold;");
		cssContent.append("	 text-transform: uppercase;}");
		cssContent.append("td{");
		cssContent.append("	 background:#ddd;");
		cssContent.append("	 font-size:0.7em;");
		cssContent.append("	 font-family: Arial, Helvetica, sans-serif;}");
		cssContent.append(".titleBar{");
		cssContent.append("	 width:100%;");
		cssContent.append("	 border-style:none;");
		cssContent.append("	 background:#000000;");
		cssContent.append("	 color:#FFFFFF;}");
		cssContent.append(".dashedTable{");
		cssContent.append("	 width:100%;");
		cssContent.append("	 background:#FFFFFF;");
		cssContent.append("	 border-style:dashed;");
		cssContent.append("	 border-width:1px;");
		cssContent.append("	 border-color:silver;}");
		cssContent.append(".HEADER {");
		cssContent.append("  FONT-SIZE: 1.2em;COLOR: #666; width: 200px;}");
		cssContent.append(".HEADERTABLE{");
		cssContent.append("  border-bottom: silver 1px solid;}");
		cssContent.append("a:link {color:#336699;}");
		cssContent.append("a:visited {color:#336699;}");
		cssContent.append("a:hover {color:#999999;}");
		cssContent.append("h1 {");
		cssContent.append("  color:#666;");
		cssContent.append("  font-size:1.6em;");
		cssContent.append("  border-bottom:1px dashed #999;");
		cssContent.append("  margin:15px 0 5px 0;");
		cssContent.append("  padding-bottom:5px;}");
		cssContent.append("h2 {");
		cssContent.append("  color:#666;");
		cssContent.append("  font-size:1.4em;");
		cssContent.append("  margin:15px 0 5px 0;");
		cssContent.append("  padding-bottom:2px;}");
		cssContent.append("h3 {");
		cssContent.append("  color:#666;");
		cssContent.append("  font-size:1.2em;");
		cssContent.append("  border-bottom:1px dashed #999;");
		cssContent.append("  margin:15px 0 5px 0;");
		cssContent.append("  padding-bottom:5px;}");
		cssContent.append("	h4 {");
		cssContent.append("  color:#666;");
		cssContent.append("  font-size:1.1em;");
		cssContent.append("  border-bottom:1px dashed #999;");
		cssContent.append("  margin:15px 0 5px 0;");
		cssContent.append("  padding-bottom:5px;}");
		cssContent.append(".contents{");
		cssContent.append("	font-size:0.7em;");
		cssContent.append("	text-transform: uppercase;}");
		cssContent.append(".code{");
		cssContent.append("	font-size:1.0em;");
		cssContent.append("	text-transform: uppercase;");
		cssContent.append("	font-family: \"Courier New\", Courier, mono;}");
		
		cssContent.append("</style>");
		return cssContent.toString();
	}
	
	protected String getStartOfHTML(String pageTitle){
		StringBuffer htmlContent = new StringBuffer();	
		htmlContent.append("<html><head>");
		htmlContent.append("<title>");
		htmlContent.append(pageTitle);
		htmlContent.append("</title>");
		htmlContent.append(getCSSForPage());
		htmlContent.append("</head><body>");
		htmlContent.append("<p align=\"right\">");
		htmlContent.append("<a href=\""+LINK_HOME+"\">WebStretch</a> ");
		htmlContent.append("[<a href=\""+LINK_REQUEST+"\">Request</a>] [<a href=\""+LINK_CONFIGSERVER+"\">Configuration</a>] [<a href=\""+LINK_STATISTICS+"\">Statistics</a>] [<a href=\""+LINK_HELP+"\">Help</a>] [<a href=\""+LINK_SHUTDOWN+"\">Shutdown</a>]");
		htmlContent.append("</p>");
		return htmlContent.toString();		
	}
	
	protected String getEndOfHTML(){
		return "</body></html>";		
	}

}
