package net.sourceforge.webstretch.response;

import java.io.BufferedOutputStream;

/**
 * @author Simon Shanks
 */
public class HelpResponse extends AbstractHTMLResponse {

	/* (non-Javadoc)
	 * @see net.sourceforge.webstretch.response.ProxyResponse#sendResultsToClient(java.io.BufferedOutputStream)
	 */
	public void sendResultsToClient(BufferedOutputStream out) throws Exception{
		StringBuffer htmlContent = new StringBuffer();
		htmlContent.append(getStartOfHTML("WebStretch Help"));
		
		htmlContent.append("<table class=\"headertable\"><tr>");
		htmlContent.append("<td class=\"header\" align=\"center\">");
		htmlContent.append("Help Contents");
		htmlContent.append("</td><td style=\"background:white;\"></td></tr></table>");
					
		htmlContent.append("<h2>List of Topics</h2>");
		htmlContent.append("<ul>");
		htmlContent.append("<li><a href=\"#shutdown\">Shutting down WebStretch</a></li>");
		htmlContent.append("<li><a href=\"#configurationfile\">Configuration File Settings</a></li>");
		htmlContent.append("<li><a href=\"#configurationsettings\">Configuration Settings</a></li>");
		htmlContent.append("<li><a href=\"#helpout\">Helping Out</a></li>");
		htmlContent.append("<li><a href=\"#reportingbugs\">Reporting Bugs</a></li>");
		htmlContent.append("<li><a href=\"#uptodate\">Keeping Uptodate</a></li>");
		htmlContent.append("</ul>");
		
		htmlContent.append("<a name=\"configurationfile\">");
		htmlContent.append("<h2>WebStretch Configuration File</h2>");
		
		htmlContent.append("<p>");
		htmlContent.append("The configuration file is a normal Java style property file. It may be altered by any text editor.");
		htmlContent.append("Any optional fields that are not required may be commented out, by placing the # character at the start of the line in which it is specified.");
		htmlContent.append("</p>");
		
		htmlContent.append("<table>");
		htmlContent.append("<tr>");
		htmlContent.append("<td>proxy.port</td><td>The port on which the proxy should run. This will be the Proxy Server Port which you will specify in your browser settings.</td>");
		htmlContent.append("</tr>");
		htmlContent.append("<tr>");
		htmlContent.append("<td>externalproxy.port</td><td><i>Optional</i> - If you already use a normal web proxy, you can specify its port here.</td>");
		htmlContent.append("</tr>");
		htmlContent.append("<tr>");
		htmlContent.append("<td>externalproxy.host</td><td><i>Optional</i> - If you already use a normal web proxy, you can specify its address here.</td>");
		htmlContent.append("</tr>");
		htmlContent.append("<tr>");
		htmlContent.append("<td>maximum.threads</td><td>Defines the maximum amount of threads the WebStretch Proxy can use</td>");
		htmlContent.append("</tr>");
		htmlContent.append("</table>");
		
		htmlContent.append("<a name=\"shutdown\">");
		htmlContent.append("<h2>Shutting down WebStretch Proxy</h2>");
		htmlContent.append("<p>");
		htmlContent.append("In order to free the port being used by WebStretch, it is advised that shutdown is performed");
		htmlContent.append("using the link above. It may be beneficial to bookmark the main <a href=\"http://webstretch\">WebStretch</a> page so that ");
		htmlContent.append("these features can be easily reached.");
		htmlContent.append("</p>");
		
		htmlContent.append("<a name=\"configurationsettings\">");
		htmlContent.append("<h2>WebStretch Configuration Settings</h2>");
		htmlContent.append("<p>");
		htmlContent.append("The WebStretch proxy may be configured from the link at the top of any of the pages located");
		htmlContent.append("locally on the WebStretch proxy (including this page).");
		htmlContent.append("</p>");
		
		htmlContent.append("<a name=\"helpout\">");
		htmlContent.append("<h2>Helping Out</h2>");
		htmlContent.append("<p>");
		htmlContent.append("Please visit the project page at SourceForge (<a href=\"http://sourceforge.net/projects/webstretch/\">http://sourceforge.net/projects/webstretch/</a>), and contact one of the admin");
		htmlContent.append("level users.");
		htmlContent.append("You may help out by");
		htmlContent.append("<ul>");
		htmlContent.append("<li>Reviewing code</li>");
		htmlContent.append("<li>Writting documentation</li>");
		htmlContent.append("<li>Testing</li>");
		htmlContent.append("<li>Writing new code or fixing existing code</li>");
		htmlContent.append("<li>Providing support/financing</li>");
		htmlContent.append("<li>Suggesting improvements</li>");
		htmlContent.append("</ul>");
		htmlContent.append("</p>");
		
		htmlContent.append("<a name=\"reportingbugs\">");
		htmlContent.append("<h2>Reporting Bugs</h2>");
		htmlContent.append("<p>");
		htmlContent.append("Please include details of the system in use, such as ");
		htmlContent.append("<ul>");
		htmlContent.append("<li>web browser</li>");
		htmlContent.append("<li>jdk version</li>");
		htmlContent.append("<li>site/page requested</li>");
		htmlContent.append("<li>webstretch settings</li>");
		htmlContent.append("</ul>");
		htmlContent.append("A bug report may be submitted via the bug page at <a href=\"http://sourceforge.net/projects/webstretch/\">http://sourceforge.net/projects/webstretch/</a>");
		htmlContent.append("</p>");

		htmlContent.append("<a name=\"uptodate\">");
		htmlContent.append("<h2>Keeping UpToDate</h2>");
		htmlContent.append("<p>");
		htmlContent.append("The latest version of WebStretch can be downloaded from <a href=\"http://webstretch.sourceforge.net\">http://webstretch.sourceforge.net</a>");
		htmlContent.append("</p>");
		htmlContent.append("<p>");
		htmlContent.append("To get the newest version of the JDK (Java Development Kit), please visit <a href=\"http://java.sun.com\">Suns Java page</a>");
		htmlContent.append("</p>");
		
		htmlContent.append(getEndOfHTML());		
		{
			// send header details		
			String headerContent=getHeaderResponse(htmlContent.toString().getBytes().length);
			out.write(headerContent.getBytes());
		}
		this.closeHeader(out);
			
		// send body
		out.write(htmlContent.toString().getBytes());
	}
}
