package net.sourceforge.webstretch.response;

import java.io.BufferedOutputStream;

/**
 * @author Simon Shanks
 */
public class IndexResponse extends AbstractHTMLResponse {

	/* (non-Javadoc)
	 * @see net.sourceforge.webstretch.response.ProxyResponse#sendResultsToClient(java.io.BufferedOutputStream)
	 */
	public void sendResultsToClient(BufferedOutputStream out) throws Exception{
		StringBuffer htmlContent = new StringBuffer();
		htmlContent.append(getStartOfHTML("WebStretch Proxy"));

		htmlContent.append("<table class=\"headertable\"><tr>");
		htmlContent.append("<td class=\"header\" align=\"center\">");
		htmlContent.append("WebStretch 0.1.6");
		htmlContent.append("</td><td style=\"background:white;\"></td></tr></table>");
			
		htmlContent.append("<h2>Aims</h2>");

		htmlContent.append("<ul>");
		htmlContent.append("<li>HTTP request editor</li>");
		htmlContent.append("<li>HTTP request/response viewing</li>");
		htmlContent.append("<li>Web application security checker</li>");
		htmlContent.append("<li>Ability to look out for strings which have been set by user</li>");
		htmlContent.append("<li>HTTP unit testing integration</li>");
		htmlContent.append("<li>Automatic error checking</li>");
		htmlContent.append("<li>HTML validator</li>");
		htmlContent.append("<li>Performance checker</li>");
		htmlContent.append("<li>Session reconstruction/mapper</li>");
		htmlContent.append("<li>Session analysis (graphs)</li>");
		htmlContent.append("<li>Page stats e.g. size breakdowns</li>");
		htmlContent.append("<li>Record parameters which change the state of a page</li>");
		htmlContent.append("</ul>");

		htmlContent.append("<h2>Todo</h2>");
		htmlContent.append("<ul>");
		htmlContent.append("<li>Save configuration settings</li>");
		htmlContent.append("<li>Cookie editor</li>");
		htmlContent.append("<li>Allow setting of web database for tailored tests</li>");
		htmlContent.append("<li>Detect different types of logins e.g. jsp,challendge response,etc</li>");
		htmlContent.append("</ul>");

		htmlContent.append("<h2>Known Problems</h2>");
		htmlContent.append("<ul>");
		htmlContent.append("<li>No SSL support</li>");
		htmlContent.append("<li>Doesnt deal with bookmarks e.g. index.html#help</li>");
		htmlContent.append("</ul>");

		htmlContent.append(getEndOfHTML());
		{
			// send header details		
			String headerContent=getHeaderResponse(htmlContent.toString().getBytes().length);
			out.write(headerContent.getBytes());
		}
		this.closeHeader(out);
			
		// send body
		out.write(htmlContent.toString().getBytes());
	}
}
