package net.sourceforge.webstretch.response;

import java.io.BufferedOutputStream;
import java.util.*;

import net.sourceforge.webstretch.server.Statistics;

/**
 * @author Simon Shanks
 */
public class StatisticsResponse extends AbstractHTMLResponse {

	/* (non-Javadoc)
	 * @see net.sourceforge.webstretch.response.ProxyResponse#sendResultsToClient(java.io.BufferedOutputStream)
	 */
	public void sendResultsToClient(BufferedOutputStream out) throws Exception{
		StringBuffer htmlContent = new StringBuffer();
		htmlContent.append(getStartOfHTML("WebStretch Statistics"));

		htmlContent.append("<table class=\"headertable\"><tr>");
		htmlContent.append("<td class=\"header\" align=\"center\">");
		htmlContent.append("Statistics");
		htmlContent.append("</td><td style=\"background:white;\"></td></tr></table>");
			
		htmlContent.append("<h2>Bytes Received</h2>");
		htmlContent.append("<p>");
		htmlContent.append("Total Received Externally (for this session) : ");
		htmlContent.append(Statistics.getToTotalBytesReceived());
		htmlContent.append(" bytes");
		htmlContent.append("</p>");	
		
		{
			htmlContent.append("<p>");
			htmlContent.append("Bytes per host : ");
			htmlContent.append("<table>");
			htmlContent.append("<tr><th>Host</th><th>Total Received Externally</th></tr>");
			
			HashMap totalsByHost=Statistics.getTotalsByHost();
			Set hostKeys=totalsByHost.keySet();
			if (hostKeys.isEmpty()){
				htmlContent.append("<tr><td width=\"50%\" align=\"center\">-");
				htmlContent.append("</td><td align=\"center\">-</td></tr>");
			}
			Iterator hostKeyIterator=hostKeys.iterator();
			while (hostKeyIterator.hasNext()){
				String host=(String)hostKeyIterator.next();
				long bytesForHost=((Long)totalsByHost.get(host)).longValue();
				
				htmlContent.append("<tr><td width=\"50%\">");
				htmlContent.append(host);
				htmlContent.append("</td><td>");
				htmlContent.append(bytesForHost);
				htmlContent.append(" bytes</td></tr>");
			}

			htmlContent.append("</table>");	
			htmlContent.append("</p>");	
		}
		
		htmlContent.append(getEndOfHTML());
		
		{
			// send header details		
			String headerContent=getHeaderResponse(htmlContent.toString().getBytes().length);
			out.write(headerContent.getBytes());
		}
		this.closeHeader(out);
			
		// send body
		out.write(htmlContent.toString().getBytes());
	}
}
